  var alpha         = "abcdefghi";
  var alphaUC       = "ABCDEFGHI";
  var cell_formulas = new Array();
  var cell_data     = new Array();
  var cells         = new Array();
  var tds           = new Array();
  var format        = new Array();
  var numRows       = 5;
  var numCols       = 5;
  var numCells      = 25;
  var status;
  var statusCell;
  var posCell;
  var formula;
  var currentCell     = null;
  var currentInx      = 0;
  var formulaHasFocus = false;
  var hasError;
  var nbsp;

  var isHidden = true;
  var cacheDisplayType;
  var x = 0;
  var y = 0;
  var cellValue = "";

  var isFormulaMode = false;
  var skipWinEvent  = false;
  var cellOverInx   = 0;

  var cellBGColor  = "white";
  var cellFGColor  = "black";

  var cacheFormatType;


  /////////////////////////
  // Selection Data Members
  /////////////////////////
  var isRangeSelected = false;
  var isMouseDown     = false;
  var isSelectAll     = false;
  var isRowSelected   = false;
  var isCellSelected  = false;
  var isColSelected   = false;

  var selectBGColor  = "blue";
  var selectFGColor  = "white";

  var startInx      = 0;
  var startRow      = 0;
  var startCol      = 0;
  var currentSelCol = 0;
  var currentSelRow = 0;

  var selectedRow   = 0;
  var selectedCol   = 0;

  ////////////////////////////////////////////
  // Methods
  ////////////////////////////////////////////

  ////////////////////////////////////////////
  function Init()
  {
    //dump("========================");
    window.onmousemove = WinMouseMove;
    window.onmousedown = WinMouseDown;
    window.onmouseup   = WinMouseUp;
    window.onmousemove = WinMouseMove;
    window.onkeyup     = WinKeyUp;

    
    sumBtn = document.getElementById("SumFormulaBtn");
    sumBtn.onmousedown=DoSumFormula;

    formula     = document.getElementById("formula");
    status      = document.getElementById("status");
    currentCell = document.getElementById("cell");

    formula.onblur  = FormulaBlur;
    formula.onkeyup = FormulaKeyUp;
    formula.onfocus = FormulaFocus;

    currentCell.onmousedown  = CellMouseDown;
    currentCell.onmouseUp    = CellMouseDown;
    currentCell.onblur       = CellBlur;
    currentCell.onkeyup      = CellKeyUp;
    currentCell.onfocus      = CellFocus;

    for (var i=0;i<numCells;i++) {
      cell_formulas[i] = "";
      cell_data[i]     = "";
      var istr         = i.toString();
      cells[i]         = GetTextCell("Cell_"+istr);
      tds[i]           = document.getElementById("TD_"+istr);
      format[i]        = 0;
    }

    statusCell = GetTextCell("statuscell");
    posCell    = GetTextCell("poscell");
    SetStatusBar("Initialized...");
    nbsp = cells[0].data;

    var body = document.getElementById("body");
	  body.onkeyup = BodyKeyUp;

    //body.focus();
    //var td = document.getElementById("TD_15");
    //td.style.border = "1px";
    //td.style.background = "#e0e0e0";
	  //cells[0].style.border = "inset 1px solid";
  }

  ////////////////////////////////////////////
  function SetSelection(aIsSelected, aInx) 
  {
    if (aIsSelected) {
      tds[aInx].style.background = selectBGColor;
      tds[aInx].style.color      = selectFGColor;
     } else {
      tds[aInx].style.background = cellBGColor;
      tds[aInx].style.color      = cellFGColor;
     }

  }


  //////////////////////////
  function SetStatusBar(aStr) 
  {
    statusCell.data = aStr;
  }

  //////////////////////////
  function DoSumFormula(e) 
  {
    //dump("DoSumFormula\n");

    SetStatusBar("Doing Sum formula...");
    isFormulaMode = true;
    currentCell.value = "=Sum();";
    skipWinEvent = true;
    //e.preventBubble();
  }

  //////////////////////////
  function DoFillFormula(aStartRow, aStartCol, aRow, aCol) 
  {
    SetStatusBar("Doing Sum formula...");
    isFormulaMode = true;
    currentCell.value = "=Sum("+alpha[aStartCol]+aStartRow+":"+alpha[aCol]+aRow+");"
  }

  //////////////////////////
  function WinKeyUp(e) 
  {
    if (skipWinEvent) {
      skipWinEvent = false;
      return;
    }
    //dump("WinKeyUp "+e.which+"\n");
    /*//dump("WinKeyUp "+e.target.toString()+"\n");
    //dump("WinKeyUp "+e.target.name+"\n");
    //dump("WinKeyUp "+e.target.id+"\n");
    //dump("WinKeyUp "+e.target.parent+"\n");
    statusCell.data = "WinKeyUp";
    */

    var newCol = currentSelCol;
    var newRow = currentSelRow;

    switch (e.which) {
      case 37 :  //left
        newCol--;
        if (newCol < 0) {
          newCol = 0;
        }
        break;

      case 38 : // up
        newRow--;
        if (newRow < 0) {
          newRow = 0;
        }
        break;

      case 39 : // right
        newCol++;
        if (newCol >= numCols) {
          newCol = numCols-1;
        }
        break;

      case 40 : // down
        newRow++;
        if (newRow >= numRows) {
          newRow = numRows-1;
        }
        break;

      case 13: // Return
        if (isHidden) {
          CellClick(currentInx);
        }
        break;
    } // switch

    if (newCol != currentSelCol || newRow != currentSelRow) {
      ClearSelectTDSelection();
      currentSelCol = newCol;
      currentSelRow = newRow;
      currentInx = (newRow * numCols) + newCol;
      SetSelection(true, currentInx);
      isCellSelected = true;
    }
  }

  //////////////////////////
  function WinMouseMove(e) 
  {
    //dump("WinMouseMove");
    //SetStatusBar("WinMouseMove");
  }

  //////////////////////////
  function WinMouseDown(e) 
  {
    //dump("WinMouseDown: "+e.target+"\n");
    // this is because we get windows before the onclick
    // and this screws up the processing of the toolbar buttons
    if (e.target.toString() == "[object HTMLInputElement]" ||
        e.target.toString() == "[object HTMLButtonElement]") {
      return;
    } 
    //dump("Before WinMouseDown skip: "+skipWinEvent+"\n");
    if (skipWinEvent) {
      skipWinEvent = false;
      return;
    }
    //dump("WinMouseDown currentInx = "+currentInx+"\n");

    ClearSelectTDSelection();
    isRangeSelected = true;
    //SetStatusBar("Win MouseDown");
	  isMouseDown = true;
	  if (cellOverInx > -1) {
      startCol      = cellOverInx % numCols;
      startRow      = Math.floor(cellOverInx / numCols);
      currentSelCol = startCol;
      currentSelRow = startRow;
	  }
    if (isFormulaMode) {
      DoFillFormula(startRow, startCol, currentSelRow, currentSelCol);
    }
    startInx = cellOverInx;
  }

  //////////////////////////
  function WinMouseUp(e) 
  {
    //dump("Before WinMouseUp skip: "+skipWinEvent+"\n");
    if (skipWinEvent) {
      skipWinEvent = false;
      return;
    }
    if (e.target.toString() == "[object HTMLInputElement]" ||
        e.target.toString() == "[object HTMLButtonElement]") {
      return;
    } 
    //dump("WinMouseUp\n");
	  isMouseDown = false;
    //SetStatusBar("WinMouseUp");
    //dump("WinMouseUp currentInx = "+currentInx+"\n");
    //dump("WinMouseUp startCol = "+startCol+"  startRow: "+startRow+" currentSelCol: "+currentSelCol+"  currentSelRow: "+currentSelRow+"\n");

    if (startCol == currentSelCol && startRow == currentSelRow) {
      isRangeSelected = false;
      isCellSelected = true;
    }
  }

  ////////////////////////////////////////////
  function BodyKeyUp(e) 
  {
    //SetStatusBar("BodyKeyUp::e "+e.which+" "+e.type+"\n");
	  //dump(statusCell.data);
  }

  ////////////////////////////////////////////
  function CellMouseDown(aInx) 
  {
    //dump("CellMouseDown\n");
    skipWinEvent = true;
  }

  ////////////////////////////////////////////
  function CellMouseMove() 
  {
	  if (isMouseDown && cellOverInx > -1) {
      SetSelection(true, cellOverInx);
    }
  }

  ////////////////////////////////////////////
  function CellMouseOver(aInx) 
  {
    //dump("CellMouseOver isMouseDown: "+isMouseDown+"  cellOverInx = "+aInx+"\n");
    cellOverInx = aInx;
	  if (isMouseDown) {
      currentSelCol = aInx % numCols;
      currentSelRow  = Math.floor(aInx / numCols);
      //dump("CellMouseOver: "+currentSelCol+","+currentSelRow+"\n");
	    if (currentSelCol >= startCol && currentSelRow >= startRow ) {
	      //dump("start: "+startCol+","+startRow+"\n");
	      //dump("curr: "+currentSelCol+","+currentSelRow+"\n");
        for (var r=startRow;r<=currentSelRow;r++) {
          for (var c=0;c<=numCols;c++) {
		        if (r <= currentSelRow) {
			        if (c >= startCol && c <= currentSelCol) {
			          var inx = (r * numCols) + c;
				        //dump("Inx = "+inx+"\n");
                SetSelection(true, inx);
				      }
            }
		      }
		    }
	    }
	  }
    if (isFormulaMode && isMouseDown) {
      DoFillFormula(startRow, startCol, currentSelRow, currentSelCol);
    }
  }

  ////////////////////////////////////////////
  function CellClick(aInx) 
  {
    dump("CellClick: "+cellOverInx+"\n");
    dump("X = "+window.getX(tds[aInx])+"\n");
    dump("Y = "+window.getY(tds[aInx])+"\n");
    dump("-CellClick: "+cellOverInx+"\n");

    // check to see if you are currently editting a cell
    if (!isHidden) {
      cellValue = currentCell.value;
	    currentCell.value = "";
      CellBlur();
      Process();
    }

    ClearSelectTDSelection();

    SetSelection(false, currentInx);

    currentInx = aInx;

    currentSelCol  = aInx % numCols;
    currentSelRow  = Math.floor(aInx / numCols);
    isCellSelected = true;
    currentCell.style.left = window.getX(tds[aInx]);//35 + (currentSelCol * 101);
    currentCell.style.top  = window.getY(tds[aInx]);//(24 * currentSelRow) + (currentSelRow * 1)+64;

    if (isHidden) {
      ShowHide();
	  } else {
	    currentCell.focus();
	    currentCell.select();
	  }

    if (isHidden) {
      SetSelection(true, currentInx);
    }

    if (cell_formulas[currentInx].length > 0) {
      formula.value = cell_formulas[currentInx];
      currentCell.value = cell_formulas[currentInx];
    } else {
      cellValue         = cell_data[aInx];
      formula.value     = cellValue;
      currentCell.value = cellValue;
      if (currentCell.value.length == 1 && currentCell.value.toString() == nbsp.toString()) {
        currentCell.value = "";
      }
    }

    posCell.data = "Cell "+alpha[currentSelCol] + currentSelRow.toString();
    UpdateToolbar();
  }

  ////////////////////////////////////////////
  function UpdateToolbar() 
  {
    var div = document.getElementById("Cell_"+currentInx);

    if (div.style.fontWeight == "bold") {
      document.getElementById("StyleBoldBtn").style.borderStyle = "inset";
    } else {
      document.getElementById("StyleBoldBtn").style.borderStyle = "outset";
    }

    if (div.style.fontStyle == "italic") {
      document.getElementById("StyleItalicBtn").style.borderStyle = "inset";
    } else {
      document.getElementById("StyleItalicBtn").style.borderStyle = "outset";
    }

    if (div.align == "left") {
      document.getElementById("AlignLeftBtn").style.borderStyle   = "inset";
      document.getElementById("AlignCenterBtn").style.borderStyle = "outset";
      document.getElementById("AlignRightBtn").style.borderStyle  = "outset";  
    } else if (div.align.length == 0 || div.align == "center") {
      document.getElementById("AlignCenterBtn").style.borderStyle = "inset";
      document.getElementById("AlignLeftBtn").style.borderStyle   = "outset";
      document.getElementById("AlignRightBtn").style.borderStyle  = "outset";  
    } else if (div.align == "right") {
      document.getElementById("AlignRightBtn").style.borderStyle  = "inset";
      document.getElementById("AlignLeftBtn").style.borderStyle   = "outset";
      document.getElementById("AlignCenterBtn").style.borderStyle = "outset";
    }

    switch (format[currentInx]) {
      case 0 : 
        document.getElementById("FormatDollarBtn").style.borderStyle  = "outset"; 
        document.getElementById("FormatPercentBtn").style.borderStyle = "outset"; 
        break;
      case 1 : 
        document.getElementById("FormatPercentBtn").style.borderStyle = "outset"; 
        document.getElementById("FormatDollarBtn").style.borderStyle  = "inset"; 
        break;
      case 2 : 
        document.getElementById("FormatDollarBtn").style.borderStyle  = "outset"; 
        document.getElementById("FormatPercentBtn").style.borderStyle = "inset"; 
        break;
    }
  }

  /////////////////////////////////////////////
  function ClearSelectTDSelection()
  {
    if (isCellSelected) {
      SetSelection(false, currentInx);
      isCellSelected = false;
    } else if (isSelectAll) {
      SelectAll(false);
    } else if (isRowSelected) {
      SelectRow(selectedRow, false);
    } else if (isColSelected) {
      SelectCol(selectedCol, false);
    } else if (isRangeSelected) {
      // do range selection
      for (var r=startRow;r<=currentSelRow;r++) {
        for (var c=0;c<=numCols;c++) {
		      if (r <= currentSelRow) {
			      if (c >= startCol && c <= currentSelCol) {
			        var inx = (r * numCols) + c;
				      //dump("Inx = "+inx+"\n");
              SetSelection(false, inx);
				    }
          }
		    }
      }
      isRangeSelected = false;
    }
  }

  /////////////////////////////////////////////
  function SelectAll(aSelect)
  {
    for (var i=0;i<numRows;i++) {
      SelectRow(i, aSelect);
    }
    isSelectAll = aSelect;
  }

  /////////////////////////////////////////////
  function SelectCol(aCol, aSelect)
  {
    selectedCol = aCol;
    var inx = aCol;
    for (var j=0;j<numRows;j++) {
      SetSelection(aSelect, inx);
      inx += numCols;
    }
    isColSelected = aSelect;
  }

  /////////////////////////////////////////////
  function SelectRow(aRow, aSelect)
  {
    //SetStatusBar("Row "+selectedRow+" is selected.";
    selectedRow = aRow;
    var inx = (aRow * numCols);
    for (var j=0;j<numCols;j++) {
      SetSelection(aSelect, inx);
      inx++;
    }
    isRowSelected = aSelect;
  }


  /////////////////////////////////////////////
  function ShowHide()
  {
    var node = document.getElementById("cell");
    if (isHidden) {
      node.style.visibility = "visible";
      //node.style.display = "inline";
      isHidden = false;
	    node.focus();
    } else {
      node.style.visibility = "hidden";
      //node.style.display = "none";
      isHidden = true;
    }
  }

  /////////////////////////////////////////////
  function GetTextCell(aName)
  {
    var node = document.getElementById(aName);
    if (node != null) {
      if (node.hasChildNodes) {
        var children = node.childNodes
        var length = children.length
        //dump("num Children: "+children.length+"\n");
        var count = 0;
        while(count < length) {
            child = children[count];
           if (child.nodeType == 3) {
              return child;
           }
           count++
        }

      } else {
        //dump("SetCellFromTextOnDiv::No text elements for node ["+aName+"]\n");
      }
    } else{
      //dump("SetCellFromTextOnDiv::Couldn't find node ["+aName+"]\n");
    }
    return null;
  }


  //////////////////////////////////////////////////
  function FindIndex(aCell) {
    var i;
    for (i=1;i<17;i++) {
      if (document.ssform.elements[i] == aCell) {
        return i;
      }
    }
    return -1;
  }

  //////////////////////////////////////////////////
  function CellBlur(e) {
    //dump("CellBlur...CurrentInx: "+currentInx+"\n");
    if (isHidden) {
      return;
    }
    var str = cellValue;
    if (str[0] == '=') {
      cell_formulas[currentInx] = str;
      if (!formulaHasFocus) {
        currentCell.value = "";
        Process();
      }
    } else {
      //dump("Setting cell_data["+currentInx+"] to ["+str+"]\n");
      if (str.length == 0) {
        str = nbsp;
      }
	    cells[currentInx].data = FormatCellStr(format[currentInx], str, currentInx);
      cell_data[currentInx]  = str;
    }

  }

  //////////////////////////////////////////////////
  function CellFocus(e) {
    //dump("CellFocus...\n");
    //SetStatusBar("CellFocus");
    if (cell_formulas[currentInx].length > 0) {
      formula.value = cell_formulas[currentInx];
    } else {
      formula.value = currentCell.value;
    }
  }


  //////////////////////////////////////////////////
  function CellKeyUp(e) {
    //dump("CellKeyUp...\n");
    skipWinEvent = true;
    //dump("CellKeyUp"+e.which+"\n");
    //SetStatusBar("CellKeyUp "+ currentCell.value);

    if (e.which == 13) {
      cellValue = currentCell.value;
      CellBlur(e);
      ShowHide();
	    currentCell.value = "";
      Process();
      if (isFormulaMode) {
        isFormulaMode = false;
        //DoFillFormula(startRow, startCol, currentSelRow, currentSelCol);
      }
      //SetStatusBar("Window has focus");
      //dump(statusCell.data+"\n");
      window.focus();
      //tds[currentInx].focus();
//dump("isRangeSelected: "+isRangeSelected+"\n");
      if ((isHidden && isRangeSelected) || (isHidden && isCellSelected)) {
        ClearSelectTDSelection();
        SetSelection(true, currentInx);
        isCellSelected = true;
      }
    } else {
      formula.value = currentCell.value;
    }
  }

  //////////////////////////////////////////////////
  function FormulaFocus(e) {
    if (cell_formulas[currentInx].length > 0) {
      formula.value = cell_formulas[currentInx];
      currentCell.value = formula.value;
    } else {
      formula.value = currentCell.value;
    }
    formulaHasFocus   = true;
    //statusCell.data      = "FormulaFocus..."+formulaHasFocus;
  }

  //////////////////////////////////////////////////
  function FormulaBlur(e) {
    formulaHasFocus = false;
  }

  //////////////////////////////////////////////////
  function FormulaKeyUp(e) {

    if (currentCell == null) {
      SetStatusBar("currentCell is null.");
      return;
    }

   //dump("FormulaKeyUp"+e.which+"\n");
    if (e.which == 13) {
      var str = formula.value;
      cellValue = formula.value;
      if (str.length > 0 && str[0] == '=') {
        cell_formulas[currentInx] = formula.value;
        cell_data[currentInx] = "";
      } else {
        cell_data[currentInx] = formula.value;
        cell_formulas[currentInx] = "";
      }
      CellBlur();
      ShowHide();
      currentCell.value = "";
      formula.value     = "";
      Process();
    } else {
      currentCell.value = formula.value;
      // don't format while typing
      cells[currentInx].data = formula.value;
      cell_data[currentInx] = formula.value;
    }
  }

  //////////////////////////////////////////////////
  function GetColInx(aCol) 
  {
    var i;
    for (i=0;i<alpha.length;i++) {
      if (aCol == alpha[i]) {
        return i;
      }
    }
    return -1;
  }

  //////////////////////////////////////////////////
  function evCell(aCol,aRow) 
  {
    for (var i=0;i<alpha.length;i++) {
      if (alpha[i] == aCol[0]) {
        dump("i = "+i+" aCol = "+aCol+" Cell "+((i*numCols)+aCol)+" = ["+cell_data[(i*numRows)+aCol]+"]\n");
        var contents = cell_data[(aRow*numRows)+i];//cells[(aRow*numRows)+i].data;
        if (contents.length == 0) 
          return 0;
        else 
          return eval(contents);       
      }
    }
    return 0;
  }

  //////////////////////////////////////////////////
  function SumFormula(aStr) 
  {
    var sym1 = aStr.substr(0,2);
    var func = aStr.substr(2,1);
    var sym2 = aStr.substr(3,2);
    //dump("SumFormula["+aStr+"] ");
    //dump("SumFormula["+sym1+"]"+"["+func+"]"+"["+sym2+"]\n");

    var colInx = GetColInx(sym1[0]);
    var rowInx = parseInt(sym1[1]);

    var colInx2 = GetColInx(sym2[0]);
    var rowInx2 = parseInt(sym2[1]);
    var total = 0;

    //dump("Start Row: "+rowInx+" End Row: "+rowInx2);
    //dump("  Start Col: "+colInx+" End Col: "+colInx2+"\n");

    for (var r=rowInx;r<=rowInx2;r++) {
      for (var c=0;c<numCols;c++) {
			  if (c >= colInx && c <= colInx2) {
			    var inx = (r * numCols) + c;
          //dump("Adding cell inx :" +inx);
          var val1 = ProcessCell(inx);
          //dump(" value was :" +val1+"\n");
          if (val1 != -1000) {
            total += val1;
          }
				}
      }
    }

    return total;

  }

  //////////////////////////////////////////////////
  function ProcessCell(aInx) 
  {
    var str = cell_formulas[aInx];
    if (str.length > 0) {
      dump("ProcessCell Formula"+aInx+" ["+str+"]\n");
      if (str[0] == '=') {
        
        var sstr = str.substr(1, str.length-1);
        /////////////////////
        // parse here formula
        /////////////////////
        inx = sstr.search("Sum");
        if (inx >= 0)  {
          var sumStr = sstr.substr(inx, sstr.length-1);
          inx = sumStr.search(")");
          sumStr = sumStr.substr(4,inx-4);
          //dump("BeforeSum["+sumStr+"] aInx = "+aInx+"\n");
          var v = SumFormula(sumStr);
          //dump("Done Sum["+v+"]  aInx = "+aInx+"\n");
          return v;

        }
        dump("before: "+sstr+"\n");
        //sstr = sstr.replace(/([:])/g,",");

        sstr = sstr.replace(/([a-zA-Z])([0-9]{1,})/g,"evCell('$1',$2)");

       /* sstr.replace("/[a-z][A-Z]([0-9])/g","evCell('$1',$2)"); */
       /* sstr.replace(/[a-z]/g,"evCell('$1')"); */

        sstr.replace(/j/g,"J");
        dump("after: ["+sstr+"]\n");

        var val = eval(sstr);
        dump("val: "+val+"\n");
        return val;
      } else {
        //var str = cells[aInx].data;
        var str = cell_data[aInx];

        dump("--ProcessCell "+aInx+" str["+str+"]\n");
        if (str.length > 0) {
          var newStr;
          if (str.indexOf(".") > -1) {
            newStr = parseInt(str);
          } else {
            newStr = parseFloat(str);
          }
          if (newStr.toString() == "NaN") {
            return str;
          } 
          return newStr;
        }
      }
    } else {
      var str = cell_data[aInx];
      dump("-ProcessCell "+aInx+" ["+str+"]\n");
      if (str.length > 0 && str[0] >= '0' && str[0] <= '9') {
        var newVal;
        if (str.indexOf(".") > -1) {
          //dump(" processed as float ");
          newVal = parseFloat(str);
        } else {
          //dump(" processed as int ");
          newVal = parseInt(str);
        }
        //dump(" newVal["+newVal+"] ");
        if (newVal.toString() == "NaN") {
          return str;
        } 
        return newVal;
      }

    }
    return -1000;
  }

  //////////////////////////////////////////////////
  function Process() 
  {
    SetStatusBar("Calculation is starting...");
    //dump("Process-----------\n");
    hasError = false;
    for (i=0;i<numCells;i++) {
      var res = ProcessCell(i);
      if (res != -1000) {
        //dump("Process value: "+res+"  str: "+res.toString()+" format: "+format[i]+"\n");
	      //cell_data[i].data = res.toString();
	      cells[i].data = FormatCellStr(format[i], res.toString(), i);
      } else if (cell_formulas[i].length > 0) {
        var x = i % numCols;
        var y = Math.floor(i / numCols)+1;
        SetStatusBar("Cell "+alpha[x] + y.toString() + " is in error");
        //formula.value = "["+cell_formulas[i]+"]["+document.ssform.elements[i+1].value+"]";
        hasError = true;
      }
    }

    if (!hasError) {
      SetStatusBar("Calculation is done...");
    }
  }

  //////////////////////////////////////////////////
  function setSize() 
  {
    currentCell.style.width = "10px";
  }

  //////////////////////////////////////////////////
  function AlignACell(aAlignType, aInx) 
  {
    skipWinEvent = true;
    //dump("AlignCell: "+aAlignType+"\n");
    var div = document.getElementById("Cell_"+aInx);
    switch (aAlignType) {
      case 0: 
        div.align = "left";
        break;

      case 1: 
        div.align = "center";
        break;

      case 2: 
        div.align = "right";
        break;
    }
  }

  //////////////////////////////////////////////////
  function FormatStrForDollars(str) 
  {
    if (str[0] == '.') {
      str = "0"+ str;
    }
    inx = str.indexOf('.');
    if (inx > 0) {
      if (str.length - 2 == inx) {
        str = str + "0";
      } else {
        str = str.substr(0, inx+3);
      }
    } else {
      str = str + ".00";
    }

    return "$"+str;
  }

  //////////////////////////////////////////////////
  function FormatCellStr(aFormatType, aStr, aInx) 
  {
    skipWinEvent = true;
    //dump("FormatCellStr: "+aFormatType+"\n");

    var div = document.getElementById("Cell_"+aInx);

    switch (aFormatType) {
      case 0: 
         return aStr;

      case 1: 
        return FormatStrForDollars(aStr);

      case 2: 
        //dump("Formatting ["+aStr+"] for percent\n");
        var newVal = parseFloat(aStr);
        if (newVal.toString() == "NaN") {
          return aStr;
        } 
        newVal *= 100.0;
        return newVal.toString() + "%";

    } // switch
    return "Bad Format ["+aFormatType+"]";
  }

  //////////////////////////////////////////////////
  function FormatACell(aFormatType, aInx) 
  {
    //dump("FormatACell: ["+cell_data[aInx]+"]  aInx: "+aInx+"\n");
    var str = "";
    if (cell_data[aInx].length > 0) {
      str = cell_data[aInx];
    } else {
      var val = ProcessCell(aInx);
      if (val != -1000) {
        str = val.toString();
      } else {
        return;
      }
    }

    if (format[aInx] == aFormatType) {
      format[aInx] = 0;
    } else {
      format[aInx] = aFormatType;
    }

    cells[aInx].data = FormatCellStr(format[aInx], str, aInx);

  }

  //////////////////////////////////////////////////
  function StyleACell(aFormatType, aCellInx) 
  {
    skipWinEvent = true;

    var div = document.getElementById("Cell_"+aCellInx);

    switch (aFormatType) {
      case 0: 
        if (div.style.fontWeight == "bold") {
          div.style.fontWeight = "normal";
        } else {
          div.style.fontWeight = "bold";
        }
        break;

      case 1: 
        if (div.style.fontStyle == "italic") {
          div.style.fontStyle = "normal";
        } else {
          div.style.fontStyle = "italic";
        }
        break;

    }
  }

  //////////////////////////////////////////////////
  function StyleFormatCell(aDoStyle, aFormatType) 
  {
    skipWinEvent = true;
    //dump("StyleFormatCell aDoStyle: "+aDoStyle+" aFormatType "+aFormatType+"\n");
    //dump("isCellSelected: "+isCellSelected+" currentInx: "+currentInx+"\n");
    if (isCellSelected) {
      switch (aDoStyle) {
				case 0: StyleACell(aFormatType, currentInx);break;
				case 1: FormatACell(aFormatType, currentInx);break;
				case 2: AlignACell(aFormatType, currentInx);break;
      }
      // this is for event distpatch problem I can't solve
      SetSelection(true, currentInx);
    } else {
    
      var sCol
      var sRow;
      var eCol;
      var eRow;

      //dump("isRangeSelected: "+isRangeSelected+"\n");
      if (isSelectAll) {
        sCol = 0;
        sRow = 0;
        eCol = numCols-1;
        eRow = numRows-1;
      } else if (isRowSelected) { 
        sCol = 0;
        sRow = selectedRow;
        eCol = numCols-1;
        eRow = selectedRow;
      } else if (isColSelected) {
        sCol = selectCol;
        sRow = 0;
        eCol = selectCol;
        eRow = numRows-1;
      } else if (isRangeSelected) {
        sCol = startCol;
        sRow = startRow;
        eCol = currentSelCol;
        eRow = currentSelRow
      }

      //dump("StyleCell: sCol: "+sCol+"  sRow: "+sRow+"  eCol: "+eCol+"  eRow: "+eRow+"\n");
      // do range selection
      for (var r=sRow;r<=eRow;r++) {
        for (var c=0;c<=numCols;c++) {
		      if (r <= eRow) {
			      if (c >= sCol && c <= eCol) {
			        var inx = (r * numCols) + c;
              //dump("StyleCell: "+inx+"\n");
              switch (aDoStyle) {
				        case 0: StyleACell(aFormatType, inx);break;
				        case 1: FormatACell(aFormatType, inx);break;
				        case 2: AlignACell(aFormatType, inx);break;
              }
				    }
          }
		    }
      }
    }
    UpdateToolbar();
  }

  //////////////////////////////////////////////////
  function FormatFontCurrentCell() 
  {
    //dump("FormatFontCurrentCell\n");
    var fontList = document.getElementById("FontSelector");
    //dump("Value: "+fontList.value+"\n");
    //dump("select: "+fontList.selectedIndex+"\n");

    //var div = document.getElementById("Cell_"+currentInx);
    //div.style.fontFamily = "sans-serif";
    
  }

  //////////////////////////////////////////////////
  function SetCell(aInx, aStr) 
  {
    cell_data[aInx] = aStr;
  }

  //////////////////////////////////////////////////
  function ExampleofJS() 
  {
    var str  = "=if (a0 == 1) {\n";
    str     += "  for (var i=5;i<numCells;i++) {\n";
    //str     += "    SetCell(i, (i*i).toString());\n";
    str     += "    cell_data[i] = (i*i).toString();\n";
    str     += "  }\n";
    str     += "};\nstr = nbsp;";
    cell_formulas[1] = str;
    var node = GetTextCell("Code");
    node.data = str;

    var div = document.getElementById("Code");
    div.style.borderStyle ="inset";
    div.style.borderWidth ="2";
    //Process();
  }

  //////////////////////////////////////////////////
  function ExampleofJSDate() 
  {
    var str  = "=if (a0 == 2) {\n";
    str     += "  var slash = '/';\n";
    str     += "  var myDate = new Date();\n";

    str     += "  cell_data[5] = myDate.getMonth().toString();\n";
    str     += "  cell_data[6] = myDate.getDay().toString();\n";
    str     += "  cell_data[7] = myDate.getYear().toString();\n";
    str     += "};\nslash = nbsp;";
    cell_formulas[1] = str;
    var node = GetTextCell("Code");
    node.data = str;

    var div = document.getElementById("Code");
    div.style.borderStyle ="inset";
    div.style.borderWidth ="2";
    //Process();
  }
